library(MASS)
#library(reshape2)
#library(car)
#library(cluster)
#library(stringr)
#library(glmnet)


setwd("C:/All_Files/1yingsstuff/Down_selection/code/Biostat_code")
#source(file="exampleFun.R")
#source(file="Function.R")
source(file="ClusteringFun.R")
### simulate an example data ####

N <- 60   ## number of individuals per arm
Narm <- 8  ## number of regimens (M)
Nclass <- 14  ## number of immune response measured
S <- diag(1,Nclass)   ## covariate matrix of immune response
delta <- 1
wt=rep(1,Nclass) # weights given to each immune response in computing AS and AR
alpha=0.05       # Non-redundancy error rate


### mean structure of immune response
M1c <- function(delta){
  out=rbind(c(delta,rep(0,13)),
     c(-delta,delta,rep(0,12)),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14))
  return(out)
}

 M <- M1c(delta)
 set.seed(1)
 simudata<- simudata.fun(N,Narm,S,M)




############## exploratory analysis #################

  ## hierarchical clustering

  out.clus<-ds.cluster(all.data.list=simudata,ncluster.method="Tibs2001SEmax",dmat.method="manhattan.meanscore",wt.eu=wt,nmax=Narm,arg.mis=F,verbose=F)

  den <- as.dendrogram(hclust(as.dist(out.clus$dmat)))
  par(mfrow=c(1,2))
  plot(den)    ### plot dendrogram
  plot(out.clus$gfun,main="",cex.main=1.6,cex.lab=1.3,cex.axis=1.3)  ## plot gap function
  cutree(as.hclust(den), k=out.clus$ncluster.full)      ## show grouping


   ### generate heatmap

   ### compute mean matrix
    AS<-NULL
    for (i in 1:length(simudata)){
      AS<-cbind(AS,apply(simudata[[i]],2,mean,na.rm=T))
    }

    meanmat.wt=t(AS)
    mm<-apply(meanmat.wt,2,mean)
    meanmat.wt=t(t(meanmat.wt)-mm)  ## centering
    rownames(meanmat.wt)<-unlist(paste('arm',1:8,sep=''))
    colnames(meanmat.wt) <- as.character(1:Nclass)
    my_palette <- colorRampPalette(c("grey70","grey10"))(n = 300)
    col_breaks = c(seq(-0.3,0.1,length=151),seq(0.1,0.3,length=150))

    #### generate heatmap


    heatmap.2(meanmat.wt,density.info="none",distfun=daisy,metric="manhattan",weights=wt,trace="none",breaks=col_breaks,
              col=my_palette,dendrogram="row",Colv="NA",main="",cex.main=1.4,labCol=paste('X',1:Nclass,sep=''),cexRow=1.2)
