
library(MASS)
#library(reshape2)
#library(car)
#library(cluster)
#library(stringr)
#library(glmnet)

setwd("C:/All_Files/1yingsstuff/Down_selection/code/Biostat_code")
source(file="RFS_Fun.R")
#source(file="Function.R")

### simulate an example data ####

N <- 60   ## number of individuals per arm
Narm <- 8  ## number of regimens (M)
Nclass <- 14  ## number of immune response measured
S <- diag(1,Nclass)   ## covariate matrix of immune response
delta <- 0.8
#delta=0.9
K.max=Narm      ## maximum possible number of regimens allowed to be selected (Q)
wt=rep(1,Nclass) # weights given to each immune response in computing AS and AR
alpha=0.05       # Non-redundancy error rate


### mean structure of immune response
M1c <- function(delta){
  out=rbind(c(delta,rep(0,13)),
     c(-delta,delta,rep(0,12)),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14),
     rep(0,14))
  return(out)
}

 M <- M1c(delta)
 set.seed(1)
 simudata<- simudata.fun(N,Narm,S,M)  ### simulate immune response data for every regimen




### RFS-I
out1a<-seq.selection.fun3.eta(all.data.list=simudata,rank.method="avg-score",nmax=3,wt.rank=wt,inferior.alpha=2*alpha/Narm/(Narm-1),verbose=T,method.adjust='holm')

### RFS-II
out2a<-seq.selection.fun3.eta(all.data.list=simudata,rank.method="avg-score",nmax=3,wt.rank=wt,inferior.alpha=alpha/(Narm-1),verbose=T,method.adjust='holm')


### RFS-III
out3a<-seq.selection.fun3.eta(all.data.list=simudata,rank.method="avg-score",nmax=3,wt.rank=wt,inferior.alpha=alpha,verbose=T,method.adjust='holm')

### RFS-IV
out4a<-seq.selection.fun3.eta(all.data.list=simudata,rank.method="avg-score",nmax=3,wt.rank=wt,inferior.alpha=alpha/2,verbose=T,method.adjust='none')
